#ifdef GL_ES//for discriminate GLES & GL
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
#define highp
#define mediump
#define lowp
#endif
varying vec2 texcoordOut;
uniform sampler2D inputImageTexture0;
varying vec2 offsetValue;
varying vec2 rangeValue;
varying vec2 scaleValue;

uniform float textureWidth;
uniform float textureHeight;

uniform float angle;

const float PI = 3.1415926535;

vec4 FishEye() {
    
    vec2 tmpOffset = vec2(offsetValue.x - 0.5, offsetValue.y - 0.5);;
    vec2 tmpRange = rangeValue;
    vec2 tmpScale = scaleValue;

    float tmpAngle = angle;
    if (angle < 0.) {
//        tmpAngle = angle * 0.2;
        // 凹镜暂时用另外一套
        vec2 p = texcoordOut.xy;
        
        float prop = textureWidth / textureHeight;
        vec2 m = offsetValue;
        
        vec2 d = p - m;
        float r = sqrt(dot(d, d));
        
        vec2 d1 = vec2(d.x, d.y);
        if (sqrt(dot(d1, d1)) > 0.5) {
            return texture2D(inputImageTexture0, texcoordOut);
        }
        
        float power = ( 2.0 * PI / (2.0 * sqrt(dot(m, m))) ) * angle * 2.;
        
        float bind;
        
//        if (prop < 1.0) bind = m.x;
//        else bind = m.y;
        bind = m.x;
        
        vec2 uv = m + normalize(d) * atan(r * power) * bind / atan(power * bind);
        
        return texture2D(inputImageTexture0, uv);
    }
    float a = 0.5 / tan(tmpAngle * PI / 2.);   // 焦距
    
    float aperture = 180.0;
    float apertureHalf = 0.5 * aperture * (PI / 180.0);
    float maxFactor = sin(apertureHalf);
    
    vec2 uv;
    vec2 xy = 2.0 * texcoordOut.xy - 1.0 + tmpOffset;
    xy = xy * tmpRange;
    float d = length(xy);
    if (d < (2.0 - maxFactor)) {
        d = length(xy * maxFactor);
        float z = sqrt(1.0 - d * d);
        //        float r = atan(d, z) / PI;
        float rx = d / tmpRange.x / (1. + z / a);
        float ry = d / tmpRange.y / (1. + z / a);
        float phi = atan(xy.y, xy.x);
        //        uv.x = r * tmpScale.x * cos(phi) + 0.5 - tmpOffset.x;
        //        uv.y = r * tmpScale.y * sin(phi) + 0.5 - tmpOffset.y;
        uv.x = (rx * cos(phi) + 1.0 - tmpOffset.x) / 2.;
        uv.y = (ry * sin(phi) + 1.0 - tmpOffset.y) / 2.;
    }
    else {
        return texture2D(inputImageTexture0, texcoordOut);
    }
    return texture2D(inputImageTexture0, uv);
}

void main() {
	gl_FragColor = FishEye();
}
