attribute vec3 position;
attribute vec2 texcoord;
varying vec2 texcoordOut;
uniform mat4 mvpMatrix;

uniform float textureWidth;
uniform float textureHeight;

uniform int textureDirection;
uniform vec2 offset;

uniform float range;
uniform float scale;

varying vec2 offsetValue;
varying vec2 rangeValue;
varying vec2 scaleValue;

void main() {
	texcoordOut = texcoord;
	gl_Position = mvpMatrix * vec4(position,1.0);

    offsetValue = offset.xy;
    rangeValue = vec2(range, range * textureHeight / textureWidth);
    scaleValue = vec2(scale * textureHeight / textureWidth, scale);

//    if (textureDirection <= 2) {
//        offsetValue = offset.xy;
//        rangeValue = range.xy;
//        scaleValue = scale.xy;
//    }
//    else {
//        offsetValue = offset.yx;
//        rangeValue = range.yx;
//        scaleValue = scale.yx;
//    }
}
