package com.meitu.wheecam.common.app

import android.os.Bundle
import android.util.Log
import com.meitu.library.analytics.Teemo
import com.meitu.library.analytics.sdk.observer.param.EventParam
import com.meitu.remote.hotfix.HotfixReporter
import com.tencent.bugly.crashreport.CrashReport

class HotfixReporterImpl : HotfixReporter {
    override fun onEvent(event: Int, data: Bundle?) {
        if (data != null) {
            try {
                val exception = data.getSerializable(HotfixReporter.Parameters.EXCEPTION) as Throwable?
                if (exception != null) {
                    CrashReport.postCatchedException(exception)
                }
            } catch (ignored: Throwable) {
                // 存在一些各种热加载的异常，无法反序列化.
            }
            data.remove(HotfixReporter.Parameters.EXCEPTION)
            val keySet = data.keySet()
            val eventParams = ArrayList<EventParam.Param>(keySet.size)
            for (key in keySet) {
                val value = data.get(key)
                if (value != null) {
                    eventParams.add(EventParam.Param(key, value.toString()))
                }
            }
            Teemo.trackEvent("mrh:$event", *eventParams.toTypedArray())
            Log.v("Hotfix", "onEvent(mrh:$event): ${eventParams.toString()}")
        } else {
            Teemo.trackEvent("mrh:$event")
            Log.v("Hotfix", "onEvent(mrh:$event)")
        }
    }
}