package com.meitu.wheecam.common.startup.initializers

import android.app.Application
import com.meitu.wheecam.common.startup.Initializer
import java.io.File

/**
 * 尝试修正各广告SDK导致的WebView文件夹相关崩溃问题.
 * Caused by:
 * java.lang.IllegalArgumentException:/data/user/0/com.meitu.wheecam/cache/WebView is not a directory.
 */
class WebViewDirectoryCrashInitializer : Initializer {
    override fun init(context: Application, processName: String?, isMainProcess: Boolean) {
        try {
            val webViewDir = File(context.cacheDir, "WebView")
            if (webViewDir.exists() && !webViewDir.isDirectory) {
                webViewDir.delete()
                webViewDir.mkdirs()
            } else {
                webViewDir.mkdirs()
            }
        } catch (ignored: Throwable) {
        }
    }
}