package com.meitu.wheecam.common.widget

import android.content.Context
import android.graphics.Canvas
import android.graphics.Color
import android.graphics.Paint
import android.graphics.Path
import android.util.AttributeSet
import android.view.View

/**
 * 向下白箭头View (用于首页提示隐私)
 * <p>
 * Created by DaveZ 2019/2/21
 */
class ArrowDownView : View {

    private lateinit var mPaint: Paint
    private lateinit var mPath: Path

    constructor(context: Context) : super(context) {
        init()
    }

    constructor(context: Context?, attrs: AttributeSet?) : super(context, attrs) {
        init()
    }

    constructor(context: Context?, attrs: AttributeSet?, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {
        init()
    }

    private fun init() {
        mPaint = Paint(Paint.ANTI_ALIAS_FLAG)
        mPaint.color = Color.WHITE
        mPaint.style = Paint.Style.FILL

        mPath = Path()


    }

    override fun onDraw(canvas: Canvas?) {
        super.onDraw(canvas)

        mPath.moveTo(0f, 0f)
        mPath.lineTo(width / 2f, height / 1f)
        mPath.lineTo(width / 1f, 0f)
        mPath.close()

        canvas?.drawPath(mPath, mPaint)
    }
}