package com.meitu.wheecam.community.utils

import android.content.Context
import com.meitu.business.ads.core.MtbPrivacyPolicy
import com.meitu.library.analytics.Teemo
import com.meitu.wheecam.community.utils.sp.SharedPreferencesUtils
import org.greenrobot.eventbus.EventBus

/**
 * Created by nuddleswhz on 2019-07-08.
 */
class PrivacyManager {


    companion object {
        private const val SHOW_PRIVACY_KEY = "show_privacy_key_v2"
        private const val PRIVACY_AUTHORIZATION_KEY = "privacy_authorization_key"

        fun shouldShowPrivacyPop(context: Context): Boolean {
            return SharedPreferencesUtils.getParam(context, SHOW_PRIVACY_KEY, true) as Boolean
        }

        fun markPrivacyPopShowed(context: Context) {
            SharedPreferencesUtils.setParam(context, SHOW_PRIVACY_KEY, false)
        }

        /**
         * 记录权限开关状态，同时发送事件通知上层更新
         */
        fun markPrivacyAuthorizationAndPostEvent(context: Context, authorized: Boolean) {
            SharedPreferencesUtils.setParam(context, PRIVACY_AUTHORIZATION_KEY, authorized)
            EventBus.getDefault().post(PrivacyAuthorizationEvent(authorized))
            if (authorized) {
                Teemo.setAllPrivacyControlls(true)
                MtbPrivacyPolicy.disablePrivacyControl();
            } else {
                MtbPrivacyPolicy.enablePrivacyControl()
            }
        }

        /**
         * 是否有授权
         */
        fun isPrivacyAuthorized(context: Context): Boolean {
            return SharedPreferencesUtils.getParam(context, PRIVACY_AUTHORIZATION_KEY, false) as Boolean

        }
    }


    class PrivacyAuthorizationEvent {
        var enable: Boolean = false

        constructor(enable: Boolean) {
            this.enable = enable
        }
    }

}