package com.meitu.wheecam.community.utils

import com.meitu.remote.config.RemoteConfig
import com.meitu.wheecam.community.bean.RemoteCustomAdBean
import com.meitu.wheecam.community.bean.RemotePrinterAdBean

object RemoteConfigHelper {
    /**
     * 原有身份证广告位 url
     */
    private const val KEY_AD_ENTRY_CUSTOM_URL = "ad_entry_custom_url"
    /**
     * 原有身份证广告位 name
     */
    private const val KEY_AD_ENTRY_CUSTOM_NAME = "ad_entry_custom_name"
    /**
     * 原有身份证广告位 iconUrl
     */
    private const val KEY_AD_ENTRY_CUSTOM_ICON = "ad_entry_custom_icon"
    /**
     * 首页印鸽广告位拦截广告位 url
     */
    private const val KEY_AD_ENTRY_PRINTER_URL = "ad_entry_printer_url"
    /**
     * 首页印鸽广告位拦截广告位 iconUrl
     */
    private const val KEY_AD_ENTRY_PRINTER_ICON = "ad_entry_printer_icon"
    /**
     * 首页印鸽广告位拦截广告位是否生效
     */
    private const val KEY_AD_ENTRY_PRINTER_ENABLE = "ad_entry_printer_enable"

    fun getRemoteCustomAdBean(): RemoteCustomAdBean {
        val url = RemoteConfig.getInstance().getString(KEY_AD_ENTRY_CUSTOM_URL)
        val name = RemoteConfig.getInstance().getString(KEY_AD_ENTRY_CUSTOM_NAME)
        val icon = RemoteConfig.getInstance().getString(KEY_AD_ENTRY_CUSTOM_ICON)
        return RemoteCustomAdBean(url, name, icon)
    }

    fun getRemotePrinterAdBean(): RemotePrinterAdBean {
        val printerEnable = RemoteConfig.getInstance().getBoolean(KEY_AD_ENTRY_PRINTER_ENABLE)
        val printerUrl = RemoteConfig.getInstance().getString(KEY_AD_ENTRY_PRINTER_URL)
        val printerIcon = RemoteConfig.getInstance().getString(KEY_AD_ENTRY_PRINTER_ICON)
        return RemotePrinterAdBean(printerUrl, printerEnable, printerIcon)
    }
}