package com.meitu.wheecam.community.utils

import android.app.Activity
import android.content.Intent
import com.google.android.gms.tasks.CancellationTokenSource
import com.meitu.business.ads.core.view.dialog.MtbCommonProgressDialog
import com.meitu.remote.plugin.host.StartActivityHandler
import com.meitu.remote.plugin.host.remotePlugin

object RemotePluginHelper {

    fun goPluginIntent(activity: Activity, intent: Intent): CancellationTokenSource {
        val loadingDialog = MtbCommonProgressDialog.Builder(activity).create()
        loadingDialog.show()
        val cancellationTokenSource = CancellationTokenSource()
        remotePlugin.startActivityTask(activity, intent, cancellationTokenSource.token)
            .addOnSuccessListener { startActivityHandler: StartActivityHandler -> startActivityHandler.start() }
            .addOnCompleteListener {
                loadingDialog.dismiss()
            }
        return cancellationTokenSource
    }
}