package com.meitu.wheecam.tool.printer

import com.google.gson.annotations.SerializedName
import com.meitu.wheecam.community.bean.BaseBean

/**
 * 拍后页照片打印-广告位实体
 * <p>
 * 对应接口：http://wiki.meitu.com/Selfiecity/adsensies/repurchase
 * <p>
 * Created by DaveZ 2018/12/17
 */
data class AdvertBean(var source: String, var icon: String, var icon1x1: String, var url: String) : BaseBean() {
    fun isEmpty(): Boolean {
        return source.isEmpty() && icon.isEmpty() && url.isEmpty() && icon1x1.isEmpty()
    }
}

/**
 * 拍后页照片打印-上中下广告位对应的数据实体
 */
data class PhotographAdvertBean(
        @SerializedName("adv_top") val topAdv: AdvertBean,
        @SerializedName("adv_middle") val middleAdv: AdvertBean,
        @SerializedName("adv_bottom") val bottomAdv: AdvertBean) : BaseBean()